// $Id: divisors.h,v 1.2 2017/03/06 04:14:06 leavens Exp leavens $
#ifndef DIVISORS_H
#define DIVISORS_H 1

/* Requires: 0 < n and divs has at least sz elements 
   and sz is at least as large as the number of divisors of n.
   Modifies: divs[*]
   Ensures: result is the number of (positive) divisors of n
            and for each i such that 0 <= i and i < result, 0 < divs[i],
            divs[i] evenly divides n (i.e., n % divs[i] == 0);
	    and if 0 < i then divs[i-1] < divs[i], so that divs is sorted
	    in increasing order (for the elements up to result).
*/
extern
int divisors(int n, int divs[], int sz);
#endif
