// $Id: test_divisors.c,v 1.2 2017/03/06 04:22:01 leavens Exp leavens $
// compile with:
// gcc tap.c divisors.c test_divisors.c -o test_divisors

#include <stdlib.h>
#include <stdio.h>
#include "tap.h"
#include "divisors.h"
#define SIZE 150

// Requires: 0 < n and divs has at least count elements
// Effect: print to stdout the count divisors of n contained in divs
void print_divisors(int n, int divs[], int count) {
    printf("divisors of %d are: ", n);
    for (int i = 0; i < count; i++) {
	printf("%d", divs[i]);
	if (i < count-1) {
	    printf(", ");
	}
    }
    printf("\n");
}

/* Check the divsors of n computed by divisors()
   and return the number of divisors of n. */
int check_divisors(int n) {
    int divs[SIZE];
    int count = divisors(n, divs, SIZE);
    print_divisors(n, divs, count);
    // 1 and n must both divide n
    ok(0 < count && divs[0] == 1 && divs[count-1] == n);
    // each element in divs must be a divisor
    for (int i = 0; i < count; i++) {
	ok(0 < divs[i] && divs[i] <= n && n % divs[i] == 0);
    }
    return count;
}

// Testing for divisors().
int main() {
    ok(check_divisors(1) == 1);
    ok(check_divisors(2) == 2);
    ok(check_divisors(3) == 2);
    ok(check_divisors(4) == 3);
    ok(check_divisors(6) == 4);
    ok(check_divisors(7) == 2);
    check_divisors(12);
    check_divisors(28);
    check_divisors(42);
    check_divisors(50);
    check_divisors(60);
    check_divisors(72);
    check_divisors(100);
    check_divisors(128);
    check_divisors(360);
    check_divisors(496);
    check_divisors(500);
    check_divisors(840);
    return exit_status();
}
